%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
LoadPath();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic 
%%%%%%%%%%%%%%%%%  ESOTHERIC, start from S, evolution during seq %%%%%%

System=Load_System_Name(16); %use systems 13, 14, 15, 16
ex = Load_System(System);
%% 
ex.B0=9.4;% Tesla
%ex.B0=0.57;% Tesla
SOTs{1} = "ESOTHERIC";
SOTs{2} = "ESOTHERICn1n2n3";
SOTs{3} = "ESOTHERICn1n2n3_CP";
SOTs{4} = "Goldman";
ex.SOT=SOTs{1};

ex.tau1v = linspace(0.0,0.400,401)';% total_delay1,3: tau1=tau3
ex.tau2v = linspace(0.0,0.400,401)';% total_delay2
ex.nRef = [3,3,3];
ex = get_INEPTmap(ex);

%%
plot_Ymap(ex,ex.Amplitudes,ex.tau1v,ex.tau2v);
if strcmp(ex.SOT,"ESOTHERICn1n2n3")
    ex.SOT=ex.SOT+sprintf("_%d_%d_%d_",ex.nRef);
end
if strcmp(ex.SOT,"ESOTHERICn1n2n3_CP")
    ex.SOT=ex.SOT+sprintf("_%d_%d_%d_",ex.nRef);
end


save("out/"+ex.SOT+ex.System+"_"+num2str(ex.B0)+"T.mat","ex");
toc


