

Ra=0.14;
Rb=0.5;
s12=0.015451;

L=[-Ra -s12;-s12 -Rb];
[Q,E] = eig(L);
Rs=-diag(E);
Ts=1./Rs

Mic = [0.1;1]; % initial conditions
M0 = [-0.1;1]; % equilibrium polarization

t = linspace(0,30,100);



% dy/dt = Ay-Ay0
% y=exp(Lt)*(Mic-M0) + y0
y=zeros(2,length(t));
for it=1:length(t)
    y(:,it)=expm(L*t(it))*(Mic-M0) + M0;    
end

figure("color","white")
plot(t,y)
legend({"a-15N","b-1H"})
grid on