Path="D:\YandexDisk\resultsKiel\120.Theis_altSABRE_kinetics\CSH-Raw Data CSV\";
PathSim="C:\Users\User\Documents\git\moin-spin-library\Coherent_SABRE_SHEATH_alt_SABRE\out\";

% load time points
File="Time Points\TimePoints.xlsx";
in=readtable(Path+File);
tpshift=-2; % tp shift [ms]
Tp=in.Var1+tpshift;



% %% load signal points %30,40,50C 
% disp("start lsqcurvefit")
% %start 11-40
% b0=[12,20,30,100, -7,-24.5, 1];
% lb=[1,  1, 1,  2,-15,  -30,-3];
% ub=[40,40,40,200, -5,  -19, 3];
% File1="Letrozole\0.5uT 30C.xlsx";
% File2="Letrozole\0.5uT 40C.xlsx";
% File3="Letrozole\0.5uT 50C.xlsx";
% [betals,res]=fit3_alt_SABRE_lsqcurvefit(Path+File1,Path+File2,Path+File3,Tp,b0,lb,ub);
% disp('results')
% disp(betals)

%% load signal points %30,40,50C 
disp("start nlfit")
b0=[12,20,30,100, -8,-26, 0]; % initial state
File1="Letrozole\0.5uT 30C.xlsx";
File2="Letrozole\0.5uT 40C.xlsx";
File3="Letrozole\0.5uT 50C.xlsx";
fittype="fixJ"; % fixJ fit fixes ratio kd/wa and all j constants as in b0
%fittype="All"; % uses b0 as initial conditions and fits 7 parameters: kd1,kd2,kd3, kd/wa, jhh, jnh1,jnh2
[betanl,R,J,CovB] = fit3_alt_SABRE_nlinfit(Path+File1,Path+File2,Path+File3,Tp,b0,fittype);
disp('results')
disp(betanl)
sqrt(diag(CovB))

%%
%b0=[9.01855954615501	15.1416189029774	21.5827329343950	69.4068443334030	-6.06987512697558	-25.4050721733037	2.99999999996803]; % initial state
b0=betanl
b0=[betanl, 100, -8, -26, 0]
File1="Letrozole\0.5uT 30C.xlsx";
File2="Letrozole\0.5uT 40C.xlsx";
File3="Letrozole\0.5uT 50C.xlsx";
show3_alt_SABRE(Path+File1,Path+File2,Path+File3,Tp,b0)   



% %% 0.5 uT % lsqcurvefit
% % load signal points %30C 
% File="Anastrozole\0.5uT 30C.xlsx";
% b0=[12, 100, -7, -24.5, 1];
% lb=[8,2,-15,-30,-3];
% ub=[15,200,-5,-19,3];
% [b30,res30] = fit_alt_SABRE_lsqcurvefit(Path+File,Tp,b0,lb,ub);
% 
% % load signal points %40C 
% File="Anastrozole\0.5uT 40C.xlsx";
% b0=[20, 100, -7, -24.5, 1];
% lb=[15,2,-15,-30,-3];
% ub=[25,200,-5,-19,3];
% [b40,res40] = fit_alt_SABRE_lsqcurvefit(Path+File,Tp,b0,lb,ub);
% 
% % load signal points %50C 
% File="Anastrozole\0.5uT 50C.xlsx";
% b0=[30, 100, -7, -24.5, 1];
% lb=[20,2,-15,-30,-3];
% ub=[40,200,-5,-19,3];
% [b50,res50] = fit_alt_SABRE_lsqcurvefit(Path+File,Tp,b0,lb,ub);

% %% 0.5 uT % nlinfit
% % load signal points %30C 
% File="Anastrozole\0.5uT 30C.xlsx";
% b0=[12, 100, -7, -24.5, 1];
% [bnl30,R30,J30,CovB30] = fit_alt_SABRE_nlinfit(Path+File,Tp,b0);
% 
% % load signal points %40C 
% File="Anastrozole\0.5uT 40C.xlsx";
% b0=[20, 100, -7, -24.5, 1];
% [bnl40,R40,J40,CovB40] = fit_alt_SABRE_nlinfit(Path+File,Tp,b0);
% 
% % load signal points %50C 
% File="Anastrozole\0.5uT 50C.xlsx";
% b0=[30, 100, -7, -24.5, 1];
% [bnl50,R50,J50,CovB50] = fit_alt_SABRE_nlinfit(Path+File,Tp,b0);



%%


function [beta1,res] = fit_alt_SABRE_lsqcurvefit(PathFile,Tp,b0,lb,ub)   
    % experiment    
    in=readtable(PathFile);
    ydata=in.Var1;
    ydata=ydata/max(ydata);
    %% simulations
    % constants in the function:
    %System="HHN-1";
    %Bp=0.5*1e-6; % T
    %TimePol=90; % s % polarization time
    % variable parameters:
    % Kd=12; % s-
    % KdWa_r=100; % Kd/Wa
    % JHH
    % JNH1
    % JNH2
    
    %ysim=function_coherent_SHEATH_SABRE_rep_tp(Kd,KdWa_r,-7,-24.5,1,Tp);    

    modelfun = @(b,x)function_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b(4),b(5),x);
    rng("default")
       
    opts = statset('nlinfit');
    opts.RobustWgtFun = 'bisquare';
    [beta1,res] = lsqcurvefit(modelfun,b0,Tp,ydata,lb,ub);
    
    ysim=modelfun(beta1,Tp);
    plotkinetics_loc(Tp,ydata,Tp,ysim);
end

function [beta1,R,J,CovB]=fit_alt_SABRE_nlinfit(PathFile,Tp,b0)   
    % experiment    
    in=readtable(PathFile);
    ydata=in.Var1;
    ydata=ydata/max(ydata);
    %% simulations
    % constants in the function:
    %System="HHN-1";
    %Bp=0.5*1e-6; % T
    %TimePol=90; % s % polarization time
    % variable parameters:
    % Kd=12; % s-
    % KdWa_r=100; % Kd/Wa
    % JHH
    % JNH1
    % JNH2
    
    %ysim=function_coherent_SHEATH_SABRE_rep_tp(Kd,KdWa_r,-7,-24.5,1,Tp);
    
%The nlinfit function will not allow parameter constraints. 
%Use lsqcurvefit for that instead.  
%Note that it is then possible to use the lsqcurvefit outputs to create statistics 
%on the parameters and the fit with nlparci and nlpredci,
%although calculating the correct confidence limits and other statistics on 
%a fit using constrained parameters may not be possible with these functions.

    modelfun = @(b,x)function_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b(4),b(5),x);
    rng("default")
       
    opts = statset('nlinfit');
    opts.RobustWgtFun = 'bisquare';
    [beta1,R,J,CovB] = nlinfit(Tp,ydata,modelfun,b0,opts);
    
    ysim=modelfun(beta1,Tp);
    plotkinetics_loc(Tp,ydata,Tp,ysim);
end

function [beta1,res] = fit3_alt_SABRE_lsqcurvefit(PathFile1,PathFile2,PathFile3,Tp,b0,lb,ub)   
    % experiment    
    in=readtable(PathFile1);
    ydata=in.Var1;    
    ydata1=ydata/max(ydata);
    in=readtable(PathFile2);
    ydata=in.Var1;
    ydata2=ydata/max(ydata);
    in=readtable(PathFile3);
    ydata=in.Var1;
    ydata3=ydata/max(ydata);
    ydata=[ydata1', ydata2', ydata3']';
    %plot(ydata)
    
    %% simulations
    % constants in the function:
    %System="HHN-1";
    %Bp=0.5*1e-6; % T
    %TimePol=90; % s % polarization time
    % variable parameters:
    % Kd=12; % s-
    % KdWa_r=100; % Kd/Wa
    % JHH
    % JNH1
    % JNH2
    
    %ysim=function_coherent_SHEATH_SABRE_rep_tp(Kd,KdWa_r,-7,-24.5,1,Tp);    

    modelfun = @(b,x)function_3_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b(4),b(5),b(6),b(7),x);
    rng("default")
                 
    [beta1,res] = lsqcurvefit(modelfun,b0,Tp,ydata,lb,ub);
    
    ysim=modelfun(beta1,Tp);
    plot3kinetics_loc(Tp,ydata,Tp,ysim);
end

function show3_alt_SABRE(PathFile1,PathFile2,PathFile3,Tp,b0)   
    % experiment    
    in=readtable(PathFile1);
    ydata=in.Var1;    
    ydata1=ydata/max(ydata);
    in=readtable(PathFile2);
    ydata=in.Var1;
    ydata2=ydata/max(ydata);
    in=readtable(PathFile3);
    ydata=in.Var1;
    ydata3=ydata/max(ydata);
    ydata=[ydata1', ydata2', ydata3']';
          
    modelfun = @(b,x)function_3_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b(4),b(5),b(6),b(7),x);
    rng("default")
    ysim=modelfun(b0,Tp);
    plot3kinetics_loc(Tp,ydata,Tp,ysim);    
end

function [beta1,R,J,CovB] = fit3_alt_SABRE_nlinfit(PathFile1,PathFile2,PathFile3,Tp,b0,fittype)   
    % experiment    
    in=readtable(PathFile1);
    ydata=in.Var1;    
    ydata1=ydata/max(ydata);
    in=readtable(PathFile2);
    ydata=in.Var1;
    ydata2=ydata/max(ydata);
    in=readtable(PathFile3);
    ydata=in.Var1;
    ydata3=ydata/max(ydata);
    ydata=[ydata1', ydata2', ydata3']';
    %plot(ydata)
    
    %% simulations
    % constants in the function:
    %System="HHN-1";
    %Bp=0.5*1e-6; % T
    %TimePol=90; % s % polarization time
    % variable parameters:
    % Kd=12; % s-
    % KdWa_r=100; % Kd/Wa
    % JHH
    % JNH1
    % JNH2
    
    %ysim=function_coherent_SHEATH_SABRE_rep_tp(Kd,KdWa_r,-7,-24.5,1,Tp);    
    switch fittype
        case "ALL"
            modelfun = @(b,x)function_3_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b(4),b(5),b(6),b(7),x);
            
        case "fixJ"
            modelfun = @(b,x)function_3_coherent_SHEATH_SABRE_rep_tp(b(1),b(2),b(3),b0(4),b0(5),b0(6),b0(7),x);            
            b0=b0(1:3);

        otherwise 
            error("only All or fixJ")
    end
    rng("default")      
    %ysim=modelfun(b0,Tp);
    %plot3kinetics_loc(Tp,ydata,Tp,ysim);
    %    asdf
    opts = statset('nlinfit');
    opts.RobustWgtFun = 'bisquare';
    [beta1,R,J,CovB] = nlinfit(Tp,ydata,modelfun,b0,opts);   
    ysim=modelfun(beta1,Tp);
    plot3kinetics_loc(Tp,ydata,Tp,ysim);
end

%%
function [ysim, Tpsim] = load_simulations(System,Bp,Kd,KdWa_r,TimePol)
    insim=load(sprintf('out\\ex_%s_Bp%.0fnT_Kd%.1fs-1_KWr%.0f.mat',[System,Bp*1e9,Kd,KdWa_r]));
    sim=insim.ex;
    n=round(TimePol./(sim.tpv+sim.td))';
    ysim=sim.Yout;
    linidx = sub2ind(size(ysim), 1:size(ysim,1), n);                 % Linear Index    
    ysim = ysim(linidx)';
    Tpsim=sim.tpv*1e3;
end


%% plot function
function RMSD = plotkinetics_loc(x,y,xsim,ysim)
    figure("Color","white")
    plot(x,y,"LineWidth",2,"Marker","o")
    hold on
    plot(xsim,ysim,"LineWidth",2,"Marker","o");
    hold off

    xlabel("tp (ms)")
    ylabel("signal")
    %axis([0,x(end),min([min(y),min(ysim)]),1])
    RMSD = rms(y-ysim);
    legend({"exp","sim"})
    title(sprintf("RMSD = %.4f",RMSD));
end

function RMSD = plot3kinetics_loc(x,y,xsim,ysim)
    y=reshape(y,length(x),3);
    ysim=reshape(ysim,length(x),3);
    figure("Color","white")
    for k=1:3
        subplot(3,1,k);
        plot(x,y(:,k),"LineWidth",2,"Marker","o")
        hold on
        plot(xsim,ysim(:,k),"LineWidth",2,"Marker","o");
        hold off
    
        xlabel("tp (ms)")
        ylabel("signal")
        %axis([0,x(end),min([min(y),min(ysim)]),1])
        RMSD = rms(y(:,k)-ysim(:,k));
        legend({"exp","sim"})
        title(sprintf("RMSD = %.4f",RMSD));
    end
end