function onlyplot_tdBd()

p=LoadPath();
System_type{1}="HHN-1";
System=System_type{1};
%folder='out5ms\';
folders{1}='out_tdBd_p3m1u_r10\';
folder=folders{1};
rep=10;

%in=load(sprintf('%s%s_tdv_Yts_rep%d.dat',folder,System,rep),'-ASCII');     
in=load(sprintf('%s%s_tdv_YBd_rep%d.dat',folder,System,rep),'-ASCII');     

Z=in(:,2:end);
Bdv=load(folder+System+'_Bd.dat','-ASCII')*1e6;  
taud=load(folder+System+'_TAUD.dat','-ASCII')*1e3;  
var=load(folder+System+".mat");

[X, Y] = meshgrid(Bdv,taud); 
texts.x = '{\it B}_{high} [\muT]';
texts.y = '\tau_{high} [ms]';
texts.title = ' ';
ax=plot2D(X,Y,Z,texts);

axis([1 60 0 50, -100,100]);
imagewd = getframe(gcf); 
imwrite(imagewd.cdata, folder+System+".tiff",'Compression','none','Resolution',300);
end

