function onlyplot_tdtp()

p=LoadPath();
System_type{1}="HHN-1";
System=System_type{1};
folders{1}='out_tdtp_p1ud54u_r10\';
folders{2}='out_tdtp_p1ud54u_r100_500m\';
folders{3}='out_tdtp_p1ud54u_r100\';
folders{4}='out_tdtp\';
folder=folders{4};
rep=100;

in=load(sprintf('%s%s_tdv_Ytp_rep%d.dat',folder,System,rep),'-ASCII');     
Z=in(:,2:end);
taup=load(folder+System+'_TAUP.dat','-ASCII')*1e3;  
taud=load(folder+System+'_TAUD.dat','-ASCII')*1e3;  
var=load(folder+System+".mat");

[X, Y] = meshgrid(taup,taud); 
texts.x = '\tau_{low} [ms]';
texts.y = '\tau_{high} [ms]';
texts.title = ' ';
ax=plot2D(X,Y,Z,texts);

axis([0 50 0 500, -100,100]);
imagewd = getframe(gcf); 
imwrite(imagewd.cdata, folder+System+".tiff",'Compression','none','Resolution',300);
end

