function Ymap = get_INEPT3map(ex,INEPT_type)
ex.H0 = 2*pi*HZJij(ex.S,ex.ChSh,ex.J,ex.B0,"full");
[Q,E0] = eig(full(ex.H0));
r0 = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2);%select spins
r0 = r0.RemoveCoherences(Q); 

%r0= DensityMatrix(ex.S.SSzznorm(ex.n1,ex.n2));
%r0 = r0.RemoveCoherences(Q);


Ymap.X=zeros(length(ex.t3v),length(ex.t2v),length(ex.t1v));
Ymap.Y=Ymap.X;
Ymap.Z=Ymap.X;
switch INEPT_type               
    case "ESOTHERIC_L"
    for it1=1:length(ex.t1v)
        it1/length(ex.t1v)*100
        t1=ex.t1v(it1); 
        rM=r0. RotationSuperOperator(pi/2,'Y',ex.S,ex.eH);        
        %3
        [X1,Y1,rM]=rM. EvolutionConstH(ex.H0,t1,0);
        %4
        rM=rM.RotationSuperOperator(pi,'X',ex.S,[ex.eH, ex.eC]);    
        %5
        [X2,Y2,rM]=rM.EvolutionConstH(ex.H0,t1,0);          
        %6
        rM1=rM.RotationSuperOperator(pi/2,'-Y',ex.S,ex.eH);            
        for it2=1:length(ex.t2v)        
            t2=ex.t2v(it2);
            %7    
            [X3,Y3,rM]=rM1.EvolutionConstH(ex.H0,t2,0);
            %8        
            rM=rM.RotationSuperOperator(pi,'X',ex.S,ex.eH);    
            %9            
            [X4,Y4,rM]=rM. EvolutionConstH(ex.H0,t2,0);            
            %10
            rM=rM.RotationSuperOperator(pi/2,'Y',ex.S,ex.eH);
            rM2=rM.RotationSuperOperator(pi/2,'X',ex.S,ex.eC);                      
            for it3=1:length(ex.t3v)        
                t3=ex.t3v(it3);
                [X5,Y5,rM]=rM2.EvolutionConstH(ex.H0,t3,0);   
                %12
                rM=rM.RotationSuperOperator(pi,'X',ex.S,[ex.eH, ex.eC]);    
                %13
                [X6,Y6,rM]=rM. EvolutionConstH(ex.H0,t3,0);                
                rM=rM.RotationSuperOperator(pi/2,'Y',ex.S,[ex.eC]);
                %rM = ESOTHERIC_L(r0,ex.H0,t1,t2,t3,ex.S,ex.eH,ex.eC);                               
                Ymap = get_Amplitudes3D(rM,ex.SOs,Ymap,it1,it2,it3);
            end                 
        end
    end
    otherwise
        error
end
end

