function Ymap = get_INEPTmapFA(ex,INEPT_type)
ex.H0 = 2*pi*HZJij(ex.S,ex.ChSh,ex.J,ex.B0,"full");
[Q,E0] = eig(full(ex.H0));
r0 = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2);%select spins
r0 = r0.RemoveCoherences(Q); 

Ymap.X=zeros(length(ex.FACv),length(ex.FAHv));
Ymap.Y=zeros(length(ex.FACv),length(ex.FAHv));
Ymap.Z=zeros(length(ex.FACv),length(ex.FAHv));

    for it1=1:length(ex.FAHv)
        it1/length(ex.FAHv)*100
        FAH=ex.FAHv(it1);    
        for it2=1:length(ex.FACv)        
        FAC=ex.FACv(it2);
        switch INEPT_type                            
            case "ESOTHERIC_L_FA_1"
                rM = ESOTHERIC_L_FA_1 (r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC);                   
            case "ESOTHERIC_L_FA_NE"
                rM = ESOTHERIC_L_FA_NE(r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC,ex.NE);   
            case "ESOTHERIC_L_CompFA_NE"
                rM = ESOTHERIC_L_CompFA_NE(r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC,ex.NE);   
            otherwise
                error
        end
        Ymap = get_Amplitudes(rM,ex.SOs,Ymap,it1,it2);
        end
    end
end

