function plot_adMFC(ex,Data)
    f=figure('Name','Measured Data','Color','white');
    subplot(3,1,1);
    plot(ex.MFC.B*1e6,Data.Z,'LineWidth',3);
    %ax=axes('Box','on');
    %ax.set('FontSize',20,'FontName','Arial','TickDir','out','TickLength',[0.02 0.025],'XMinorTick','on','YMinorTick','on','Box','on','LineWidth',1);
    xlabel("MFC field [uT]");
    ylabel("Polarization %");

    subplot(3,1,2);
    plot(ex.MFC.t,Data.Z,'LineWidth',3);
    %ax=axes('Box','on');
    %ax.set('FontSize',20,'FontName','Arial','TickDir','out','TickLength',[0.02 0.025],'XMinorTick','on','YMinorTick','on','Box','on','LineWidth',1);
    xlabel("time [s]");
    ylabel("Polarization [%]");

    subplot(3,1,3);
    plot(ex.MFC.t,ex.MFC.B*1e6,'LineWidth',3);
    %ax=axes('Box','on');
    %ax.set('FontSize',20,'FontName','Arial','TickDir','out','TickLength',[0.02 0.025],'XMinorTick','on','YMinorTick','on','Box','on','LineWidth',1);
    xlabel("time [s]");
    ylabel("MFC field [uT]");       
end

