clear all
close all
tic
% t = [0:8000];
% S = sin(0.2*pi*t);
% X = S + rand(size(t));
% Y = nufft(X,t);
% n = length(t);
% f = (0:n-1);
% figure
% plot(t-1,abs(Y))

% Time   = [0:0.01:1 1.05:0.02:3]                                                                    ; % time domain
% model  = @(Time)(2*sin(2*pi*0.54*Time) + sin(2*pi*19*Time)).*exp(-3*Time)+0.2*(rand(size(Time))-0.5)  ;
% 
% Signal = model(Time)                                                                               ;
% FRQ    = linspace(-10,50,500)                                                                      ;
% 
% Y      = nufft(Signal,Time,FRQ)                                                                     ;
% 
% % plot
% subplot(2,2,1)                                ;
% title("nonuniform")
% plot(Time,Signal)
% xlabel("time (s)")
% subplot(2,2,3)                                                             ;
% plot(FRQ,abs(Y))
% xlabel("Frequency (Hz)")
% 
% % uniform fft
% Time = linspace(0,Time(end),length(Time)); % time domain
% Signal=model(Time);
% ZF=4; % zerofilling 
% Y = fft(Signal,length(Time)*ZF);
% L=length(Y);
% P2 = abs(Y);
% P1 = P2(1:L/2+1);
% P1(2:end-1) = 2*P1(2:end-1);
% Fs=1/(Time(2)-Time(1));
% FRQ = Fs*(0:(L/2))/L;
% 
% % plot
% subplot(2,2,2);
% title("uniform")
% plot(Time,Signal)
% xlabel("time (s)")
% subplot(2,2,4);
% plot(FRQ,P1)
% xlabel("Frequency (Hz)")


%data_in       = load('P:\user_permanent\Charbel_Assaf\0_NMR_Data\1_NMR400\20230815_2_13C_Pyr_3\adjusted\20230815_CA_2_13C_Pyr_3_exp24_JC2Hb_24.09ppm_adjusted2.csv','-ASCII'); 
data_in       = load('P:\user_permanent\Charbel_Assaf\0_NMR_Data\1_NMR400\20230823_2_13C_Pyr_4\20230823_CA_2_13C_Pyr_3_exp19_JC2Ha_29.1ppm_[1]_256K_adjusted.csv','-ASCII'); 

data.tau      = (data_in(:,1)+6)/1000;
LB=0;
GM=0;
data.y        = data_in(:,2).*exp(LB*data.tau).*exp(-GM*data.tau.^2)                                               ;
FRQ           = linspace(0,10,500)                                          ;

Y             = nufft(data.y,data.tau,FRQ)                                 ;


set(gcf,'color','w')                                                       ;
subplot(2,1,1)                                                             ;
plot(data.tau,data.y)
xlabel("time (s)")
subplot(2,1,2)                                                             ;
plot(FRQ,-imag(Y))
xlabel("Frequency (Hz)")


toc