% Define the folder and file name
tic
folder          = 'IrHH_data\kd_IrHH_temp_[2]'                             ; % Replace with your actual folder path
file_name       = 'kd_IrHH_Hb_temp_277_[2].txt'                            ; % Replace with your file name
input_file      = fullfile(folder, file_name)                              ;
output_file     = fullfile(folder, strrep(file_name, '.txt', '.txt'))      ;

% Read the data
data            = readmatrix(input_file)                                   ;

% Swap columns 2 and 3
data(:, [4,5,6]) = data(:, [5,6,4])                                        ;

% % Add two columns of zeros (columns 4 and 5)
% num_rows        = size(data, 1)                                            ; % Determine the number of rows
% zeros_columns   = zeros(num_rows, 2)                                       ; % Create two columns of zeros
% data            = [data(:, 1:3), zeros_columns, data(:, 4:end)]            ; % Insert zeros as columns 4 and 5

% Write back to a new file
writematrix(data, output_file, 'Delimiter', 'tab')                         ;

disp(['Modified file saved as ', output_file])                             ;


toc