% Reiner room temperature
% It was 5.0°C for 2-13C and 4.8°C for 1-13C



T=273+5
%T=273+25
y = exp(-6531.78/T + 26.21346)  %[1]  y is ln (R-1) and x temp in K T=249;
y = exp(-5282.99/T + 19.71017)  %[2]  y is ln (R-1) and x temp in K T=268


%MOD2 115   1C Pyruvate done
%MOD2 100   1C Pyruvate done
%MOD2 85   1C Pyruvate done
%MOD2 75   1C Pyruvate done
%MOD2 40   1C Pyruvate done
%MOD2 30   1C Pyruvate done
%MOD2 20   1C Pyruvate done
%MOD2 15   1C Pyruvate done
%MOD2 10   1C Pyruvate done

%exC 84.9  2C Pyruvate        JHC=-6;    JaC=-0.93; JbC=0.0; % done
%exC 85.1  2C Pyruvate        JHC=6;     JaC= 0.93; JbC=0.0; % done
%exC 85.2  2C Pyruvate        JHC=6;     JaC=-0.93; JbC=0.0; % done

%MOD2 29.9  2C Pyruvate       JHC=-6;    JaC=-0.93; JbC=0.0; % done
%MOD2 30.1  2C Pyruvate       JHC=+6;    JaC=0.93; JbC=0.0; % done
%MOD2 30.2  2C Pyruvate       JHC=+6;    JaC=-0.93; JbC=0.0; % done

%exC 85   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%exC 35   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%exC 30   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%exC 15   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%exC 10   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%exC 7    2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done

%MOD2 85  2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%MOD2 30  2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done
%MOD2 4   2C Pyruvate         JHC=-6;    JaC=0.93; JbC=0.0; % done

%MOD2 29.9  2C Pyruvate[2]    JHH=-6.55; JHC=-6;     JaC=-2.69; JbC=0.0; % done
%MOD2 30    2C Pyruvate[2]    JHH=-6.55; JHC=-6;     JaC=2.69; JbC=0.0; % done
%MOD2 30.1  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69; JbC=0.0; % done

%MOD2 30.2  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.0; % done 
%MOD2 25.2  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.0; % done 
%MOD2 20.2  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.0; % done

%MOD2 9.9  2C Pyruvate[2]    JHH=-6.55; JHC=-6;     JaC=-2.69; JbC=0.0; % done
%MOD2 10    2C Pyruvate[2]    JHH=-6.55; JHC=-6;     JaC=2.69;  JbC=0.0; % done
%MOD2 10.1  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69;  JbC=0.0; % done
%MOD2 10.2  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.0; % done

%MOD2 25.22  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69; JbC=0.41; % done
%MOD2 20.22  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69; JbC=0.41; % done
%MOD2 15.22  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69; JbC=0.41; % done
%MOD2 10.22  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=2.69; JbC=0.41; % done

%MOD2 25.19  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.41; % done
%MOD2 20.19  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.41; % done
%MOD2 15.19  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.41; % done
%MOD2 10.19  2C Pyruvate[2]    JHH=-6.55; JHC=+6;     JaC=-2.69; JbC=0.41; % done


%% Rainer
Folder="D:\YandexDisk\resultsKiel\125.ZULF_ULF_Kai_Rainer\Data\FieldDependence\";
p1=load(Folder+'p1.csv');
p1Std=load(Folder+'p1Std.csv');
p2=load(Folder+'p2.csv');
p2Std=load(Folder+'p2Std.csv');

figure('color','white');
errorbar(p1(:,1),p1(:,2),p1Std(:,2), 'Color','blue','LineStyle','none','Marker','.', 'MarkerSize',10)
hold on
errorbar(p2(:,1),p2(:,2),p2Std(:,2), 'Color','red','LineStyle','none','Marker','.', 'MarkerSize',10)

xlabel('Magnetic field (nT)')
ylabel('Signal (norm.)')
axis([0,1000,0,1.2])

legends={"1-^1^3C-Pyruvate-Rainer";"2-^1^3C-Pyruvate-Rainer"};
legend(legends)

%% Kai
Folder="D:\YandexDisk\resultsKiel\125.ZULF_ULF_Kai_Rainer\Data\FieldDependence\";
p1=load(Folder+'1-13CKai.csv');
p2=load(Folder+'2-13CKai.csv');

p1max=max(max(abs([p1(:,2)])));
p2max=max(max(abs([p2(:,2)])));

figure('color','white');
plot(p1(:,1)*1e3,-p1(:,2)/p1max, 'Color','blue','LineStyle','none','Marker','*', 'MarkerSize',10)
hold on
plot(p2(:,1)*1e3,-p2(:,2)/p2max, 'Color','red','LineStyle','none','Marker','*', 'MarkerSize',10)
xlabel('Magnetic field (nT)')
ylabel('Signal (norm.)')
axis([0,1000,0,1.2])


%legends={         "1-^1^3C-Pyruvate-Kai";   "2-^1^3C-Pyruvate-Kai"};
%legend(legends)

%% 1C MOD2

%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd10MOD2.mat');
%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd20MOD2.mat');

%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd85MOD2.mat'); % Rainer
%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd100MOD2.mat'); % Rainer
%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd115MOD2.mat'); % Rainer

ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd40MOD2.mat'); % Kai
ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd30MOD2.mat'); % Kai
ex=ex.ex;
S1H=ex.Yout.s{1}';
S13C=ex.Yout.s{2}';
MF=ex.Bv*1e9;
Signal=S13C/max(S13C);
hold on
plot(MF,Signal,"Color","blue","LineWidth",2,"LineStyle","--")

%% 2C[2] MOD2

%
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd9.9MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd10.2MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd10.1MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd10MOD2.mat');


%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd30MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd29.9MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd30.1MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd30.2MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd25.2MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd20.2MOD2.mat');

%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd25.22MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd20.22MOD2.mat');

%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd15.22MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd10.22MOD2.mat');

ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd25.19MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd20.19MOD2.mat');

%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd15.19MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate[2]_B_Kd10.19MOD2.mat');

ex=ex.ex;
S1H=ex.Yout.s{1}';
S13C=ex.Yout.s{2}';
asdf
Signal=S13C/max(S13C);
MF=ex.Bv*1e9;
hold on
plot(MF,Signal,"Color","red","LineWidth",2,"LineStyle","--")

%% 2C MOD2
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd85MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd10MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd30MOD2.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd30.1MOD2.mat');
ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd30.2MOD2.mat');
ex=ex.ex;
S1H=ex.Yout.s{1}';
S13C=ex.Yout.s{2}';
MF=ex.Bv*1e9;
hold on
plot(MF,S13C/max(S13C),"Color","red","LineWidth",2,"LineStyle","--")

%% 1C exC
%ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd85exC.mat');
ex=load('out\SABRESHEATH_HH-1C-Pyruvate_B_Kd10exC.mat');
ex=ex.ex;
S13C=ex.Yout.c{3}';
MF=ex.Bv*1e9;
hold on
plot(MF,S13C/max(S13C),"Color","blue","LineWidth",2)

%% 2C exC
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd84.9exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd85exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd85.1exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd85.2exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd35exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd15exC.mat');
%ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd7exC.mat');
ex=load('out\SABRESHEATH_HH-2C-Pyruvate_B_Kd10exC.mat');
% 84.9   2C Pyruvate         JHC=-6;     JaC=-0.93; JbC=0.0;
% 85   2C Pyruvate         JHC=-6;     JaC=0.93; JbC=0.0; % done
% 85.1 2C Pyruvate         JHC=6;     JaC=0.93; JbC=0.0;
% 85.2 2C Pyruvate         JHC=6;     JaC=-0.93; JbC=0.0;

ex=ex.ex;
S13C=ex.Yout.c{3}';
MF=ex.Bv*1e9;
hold on
plot(MF,S13C/max(S13C),"Color","red","LineWidth",2)

legends={"1-^1^3C-Pyruvate-Rainer";"2-^1^3C-Pyruvate-Rainer";
         "1-^1^3C-Pyruvate-Kai";   "2-^1^3C-Pyruvate-Kai";
        "1-MOD2";"2-MOD2";"1-eX";"2-eX"};
legend(legends)