in=load("out\RF_SHEATH_SABRE_HH-C_vrf_v1_time100s.mat");
in=load("out\RF_SHEATH_SABRE_HHP-C_vrf_v1_time100s.mat");

sim=in.data;
%plot_all_ULF_SLIC_SABRE(sim.System,sim.Yout.c,sim.ex,sim.ex.show_c);
%plot_all_ULF_SLIC_SABRE_voffset_v1(sim.System,sim.Yout.c,sim.ex,[1,2,3],sim.ex.SOcStr,"Polarization")
%plot_all_ULF_SLIC_SABRE_voffset_v1(sim.System,sim.Yout.c,sim.ex,[4,5,6],sim.ex.SOcStr,"Polarization")


%% HH-C
% figure("Color","White")
% k=12;
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum SLIC SABRE between 0.75 and 0.5 uT")
% legend("B_1="+num2str(6.728286/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% k=13;
% plot(-sim.ex.vrfv,sim.Yout.c{1}(:,k)*100)
% title("X polarization, optimum SLIC SABRE about 1 uT")
% legend("B_1="+num2str(6.728286/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% k=180;%206
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum SLIC SABRE between 0.75 and 0.5 uT")
% legend("B_1="+num2str(6.728286/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% plot(6.728286/26.75222080*sim.ex.B1*1e6,[max((sim.Yout.c{2}(:,:))*100); min((sim.Yout.c{2}(:,:))*100)])
% title("max and min Z polarization (B1)")
% xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% plot(6.728286/26.75222080*sim.ex.B1*1e6,[max((sim.Yout.c{1}(:,:))*100); min((sim.Yout.c{1}(:,:))*100)])
% title("max and min X polarization (B1)")
% xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% k=89;%206 168-40
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum RF SABRE at about between 20 and 50 uT")
% legend("B_1="+num2str(6.728286/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% FRQ=-sim.ex.vrfv(300:end);
% B1=6.728286/26.75222080*sim.ex.B1(10:end)*1e6;
% Z=sim.Yout.c{2}(300:end,10:end)*100;
% [mm, nm1]=max(Z);
% [mm, nm2]=min(Z);
% figure("Color","White")
% plot(B1',[FRQ(nm1)',FRQ(nm2)'],"LineWidth",2)
% 
% title("RF optimum FRQ(B1)")
% xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
% ylabel('Frequency (Hz)'    ,'FontSize',12,'FontName','Arial');
% 
% 
% gH=26.75222080*1e7;
% gC=6.728286*1e7;
% B0=50*1e-6;
% vC=gC*B0/(2*pi);
% vH=gH*B0/(2*pi);
% vrfA=linspace(0,3000,1000)';
% B1A=(2*pi)/(gH-gC/8)*((vC-vrfA).^2-(vH-vrfA).^2).^0.5;
% hold on
% plot(B1A*1e6,vrfA,'Color',"green","LineWidth",2)
% legend(["max", "min","analytica"]);


%% HHP-C
% figure("Color","White")
% plot(10.8394/26.75222080*sim.ex.B1*1e6,[max((sim.Yout.c{2}(:,:))*100); min((sim.Yout.c{2}(:,:))*100)])
% title("max and min Z polarization (B1)")
% xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');
% 
% figure("Color","White")
% plot(10.8394/26.75222080*sim.ex.B1*1e6,[max((sim.Yout.c{1}(:,:))*100); min((sim.Yout.c{1}(:,:))*100)])
% title("max and min X polarization (B1)")
% xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

% figure("Color","White")
% k=12;
% plot(-sim.ex.vrfv,sim.Yout.c{1}(:,k)*100)
% title("X polarization, optimum SLIC SABRE about 1 uT")
% legend("B_1="+num2str(10.8394/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');
% 
% figure("Color","White")
% k=11;
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum SLIC SABRE between 0.75 and 0.5 uT")
% legend("B_1="+num2str(10.8394/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');


% figure("Color","White")
% k=108;%206
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum RF SABRE at about between 20 and 50 uT")
% legend("B_1="+num2str(10.8394/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');
% 
% figure("Color","White")
% k=58;%206 168-40
% plot(-sim.ex.vrfv,sim.Yout.c{2}(:,k)*100)
% title("Z polarization, optimum RF SABRE at about between 20 and 50 uT")
% legend("B_1="+num2str(10.8394/26.75222080*sim.ex.B1(k)*1e6,3)+" uT",'FontSize',12,'FontName','Arial');
% xlabel('RF frequency (Hz)','FontSize',12,'FontName','Arial');
% ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');

FRQ=-sim.ex.vrfv(300:end);
B1=10.8394/26.75222080*sim.ex.B1(10:end)*1e6;
Z=sim.Yout.c{2}(300:end,10:end)*100;
[mm, nm1]=max(Z);
[mm, nm2]=min(Z);
figure("Color","White")
plot(B1',[FRQ(nm1)',FRQ(nm2)'],"LineWidth",2)

title("RF optimum FRQ(B1)")
xlabel('B1 (uT)','FontSize',12,'FontName','Arial');
ylabel('Frequency (Hz)'    ,'FontSize',12,'FontName','Arial');


gH=26.75222080*1e7;
gC=10.8394*1e7;
B0=50*1e-6;
vC=gC*B0/(2*pi);
vH=gH*B0/(2*pi);
vrfA=linspace(0,6000,1000)';
B1A=(2*pi)/(gH-gC/3)*((vC-vrfA).^2-(vH-vrfA).^2).^0.5;
hold on
plot(B1A*1e6,vrfA-165,'Color',"green","LineWidth",2)
legend(["max", "min","analytica"]);


