LoadPath();

% no adiabatic pulse [1]
in=load("P:\public\section\own_contributions\papers\2025_MS_experimental_approach_of_SLIC-SABRE\Data\Simulations\20250124_realSLIC_SHEATH_SABRE_HH-C_49.96uT_2uT.mat");
in2=load("P:\public\section\own_contributions\papers\2025_MS_experimental_approach_of_SLIC-SABRE\Data\Simulations\20250124_SLIC_SHEATH_SABRE_HH-C_tSLIC_1uT_49.9526uT.mat");

ex=in.ex;
%ex
PXC = ex.Yout.kin(:,1)*1;
PZC = ex.Yout.kin(:,2)*1;
PYC = ex.Yout.kin(:,3)*1;

ex.Yout.abs=(PXC.^2+PYC.^2).^0.5;
plot(ex.slic.time,ex.Yout.kin(:,1:3))
xlabel("time slic, s")
ylabel("polarizaiton %")
hold on
plot(ex.slic.time,ex.Yout.abs,"LineWidth",2)
legend(["x","z","y","tr"])
hold off

out=[ex.slic.time',ex.Yout.kin(:,1:3),ex.Yout.abs];
save("P:\public\section\own_contributions\papers\2025_MS_experimental_approach_of_SLIC-SABRE\Data\Simulations\slictime_direct.txt","out","-ASCII")

figure
ex2=in2.data;
x = ex2.ex.timeRFv';
Px2 = squeeze(Yout.c{1})*100;
Pz2 = squeeze(Yout.c{2})*100;
Py2 = squeeze(Yout.c{3})*100;

figure('Color','white','Units',"pixels",'Position', [10 100 600 700])
plot(x,[Px2,Pz2,Py2],"LineWidth",1.5);
ax = gca; 
ax.set('FontSize',12,'FontName','Arial');        
title(sprintf(System+"("+"C"+")"+' '+ex.SOcStr{ex.show_c(1)}+', k_d''=%.2f s^-^1',[ex.Kd]),'FontSize',10,'FontName','Arial');
xlabel('time SLIC PULSE (s)','FontSize',12,'FontName','Arial');
ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');
hold on
plot(ex.slic.time,ex.Yout.abs,"LineWidth",2)
legend(["x-rf","z-rf","y-rf","tr"])
hold off
out=[x,Px2,Pz2,Py2];
save("P:\public\section\own_contributions\papers\2025_MS_experimental_approach_of_SLIC-SABRE\Data\Simulations\slictime_rotationframe.txt","out","-ASCII")
