function [y] = SABRE_IrHH_threesite_exchange_Lmatrix_noKap(MHa,MHb,MH2,const,kd,kex,RH2,RHab,x)
                                                                              

            L = [-kd-RHab-kex     kex              (kd*const)/2            ;    
                kex           -kd-RHab-kex         (kd*const)/2            ;   
                kd              kd              -(kd*const)-RH2]           ;

            M0 = [MHa; MHb; MH2]                                           ;

            y1 = zeros(length(x)/3,1)                                      ;
            y2 = y1                                                        ;
            y3 = y1                                                        ;
                for ix = 1:length(x)/3
                     M = expm(L*x(ix))*M0                                  ; 
                   y1(ix)= M(1)                                            ;
                   y2(ix)= M(2)                                            ;
                   y3(ix)= M(3)                                            ;
                end

            y = [y1; y2; y3]                                               ;
end