function [y] = SABRE_hydrogen_exchange_Lmatrix_pre2(MHC1, MH2, Rf, kd1, kaprime1, R1, x)
                                                                            

            L = [-kd1-R1         kaprime1                                  ;    
                   kd1          -Rf-kaprime1]                              ;
            
            

            M0 = [MHC1;  MH2]                                              ;

            y1 = zeros(length(x)/2,1)                                      ;
            y2 = y1                                                        ;
            
                for ix = 1:length(x)/2
                     M = expm(L*x(ix))*M0                                  ; 
                   y1(ix)= M(1)                                            ;
                   y2(ix)= M(2)                                            ;
                end

            y = [y1; y2]                                                   ; 
end