function [y] = SABRE_twosite_exchange_LmatrixK(S0,Ir0,Mb,Mr,Mf,Rf,K, kd,ka,Rb,x)
                                                    
            S    = Substrate_concentration(kd,ka,S0,Ir0)                   ;                           
           % CsS2                          = S0-2*Ir0-S                    ;       
           %  CsS                           = Ir0-CsS2                     ;
           %   K       = S/CsS2                                            ;
           %  kaprime = ka*CsS                                             ;

            L = [-kd-Rb     ka*S           kd/K                            ;    
                0.5*kd    -ka*S-Rb           0                             ;   
                0.5*kd       0            -kd/K-Rf]                        ;

            M0 = [Mb; Mr; Mf]                                              ;

            y1 = zeros(length(x)/2,1)                                      ;
            y2 = y1                                                        ;
            y3 = y1                                                        ;
                for ix = 1:length(x)/2
                     M = expm(L*x(ix))*M0                                  ; 
                   y1(ix)= M(1)                                            ;
                   y2(ix)= M(2)                                            ;
                   y3(ix)= M(3)                                            ;
                end

            y = [y1; y3]                                                   ;
end