function [y] = SABRE_twosite_exchange_Lmatrixka(x,S0,Ir0,Mb,Mf,Mr,C,kd,Rb,Rf)
            ka   = kd*C                                                    ;
            S    = Substrate_concentration(kd,ka,S0,Ir0)                   ;


            L = [-kd-Rb     ka*S             ka                            ;    
                0.5*kd    -ka*S-Rb           0                             ;   
                0.5*kd       0            -ka-Rf]                          ;

            M0 = [Mb; Mf; Mr]                                              ;

            y1 = zeros(length(x)/2,1)                                      ;
            %y2 = y1                                                       ;
            y3 = y1                                                        ;
                for ix = 1:length(x)/2
                     M = expm(L*x(ix))*M0                                  ; 
                   y1(ix)= M(1)                                            ;
                  % y2(ix)= M(2)                                           ;
                   y3(ix)= M(3)                                            ;
                end

            y = [y1; y3]                                                   ;
end