function plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout,ex,show,SOstr,where)
    %x=ex.offsetv;
    x=-ex.vrfv;
    leg=ex.B1'*1e6;       
    figure('Color','white','Units',"pixels",'Position', [10 100 600 700])
    colormap('jet');%hot        
    for ik = 1:length(show)
        it=length(ex.timeRFv);
        timeRF=ex.timeRFv(it);
        
        ax1=subplot(length(show),1,ik);
        plot(x,(Yout{show(ik)}(:,:,it))*100)        
        ax1.set('FontSize',12,'FontName','Arial');
        if ik==1
            title(sprintf(System+"("+where+")"+' '+SOstr{show(ik)}+', t_S_L_I_C = %.2f s, k_d''=%.2f s^-^1',[timeRF, ex.Kd]),'FontSize',10,'FontName','Arial');
        else
            title(sprintf(SOstr{show(ik)}),'FontSize',10,'FontName','Arial');
        end
        %xlabel('13C frequency offset (Hz)','FontSize',12,'FontName','Arial');
        xlabel('SLIC frequency (Hz)','FontSize',12,'FontName','Arial');
        ylabel('Polarization (%)'    ,'FontSize',12,'FontName','Arial');
        legend("B_1="+num2str(leg,3)+" uT",'FontSize',12,'FontName','Arial');
    end
end

