function plot_all_tdtp(System,Yout,ex)
    [X, Y]=meshgrid(ex.tpv*1e3,ex.tdv*1e3);
    irep=ex.rep;
    figure
    colormap('jet');%hot
    ax1=axes;
    surf(ax1,X,Y,Yout(:,:,irep),'EdgeColor', 'None', 'facecolor', 'interp');    
    ax1.set('FontSize',14,'FontName','Times New Roman');
    view(2); colorbar;
    title(sprintf(System+' I_Z %%, W_a=%.3f s^-^1, k_d''=%.3f s^-^1, rep=%d',[ex.Wa ex.Kd irep]),'FontSize',16,'FontName','Times New Roman');
    xlabel('\tau_p, ms','FontSize',14,'FontName','Times New Roman');
    ylabel('\tau_d, ms','FontSize',14,'FontName','Times New Roman');
    axis([ex.tpv(1)*1e3 ex.tpv(end)*1e3 ex.tdv(1)*1e3 ex.tdv(end)*1e3]);
end

